@echo off
set op_Iterations=10000
set op_Timeout=60
set op_Beep=FALSE
set op_indPrimeLog=FALSE
set op_conncet=FALSE
cls
echo +-------------------------------------+
echo ^| LLRnet client V0.9b7 with cLLR V3.8 ^|
echo ^| K.Bonath, 2010-02-10, Version 0.8   ^|
echo +-------------------------------------+
echo.
echo Current configuration:
findstr /b "server" llr-clientconfig.txt
findstr /b "port" llr-clientconfig.txt
findstr /b "username" llr-clientconfig.txt
findstr /b "WUCacheSize" llr-clientconfig.txt
echo.

if %1:==-c: goto jobcancel
if not exist workfile.txt goto do_llrnet

:start

REM found a LLR save-file -> do LLR
if exist z* goto do_cllr

if exist workfile.txt goto do_cllr

REM convert LLR-resultfile into LLRnet-result file
if not exist lresults.txt goto error_nolres
if not exist workfile.res goto error_nolres
gawk -f do_tosend.awk lresults.txt
del workfile.bak

REM add current results to history
type lresults.txt >>lresults_hist.txt

REM delete old files
del lresults.txt workfile.res workfile.txt llr.ini

REM receive/submit workunits from/to LLRnet-server
if not exist tosend.txt goto error_notos
echo OutputIterations=%op_Iterations% >llr.ini

:do_llrnet
llrnet

REM should be empty, but also delete
if exist tosend.txt del tosend.txt

if not exist workfile.txt goto error_noconnection

REM LLR processes all reserved workunits
:do_cllr
if not exist workfile.txt goto error_nowork
cllr -d workfile.txt
set /p =[%Date:~-4%-%Date:~-7,2%-%Date:~-10,2% %Time:~,8%] <nul >>lresults.txt
echo.>>lresults.txt

for %%F in (workfile.res) do set wsize=%%~zF
if %wsize% LSS 30 goto no_prime

set p_file=primes.txt
if %op_indPrimeLog%==TRUE goto primelog
set p_file=..\primes.txt

:primelog
gawk "index($0,\" \")>0 {print strftime(\"[%%Y-%%m-%%d %%H:%%M:%%S]\")\" \"$0}" workfile.res >>%p_file%

if %op_Beep%==FALSE goto no_prime

:no_prime
ren workfile.txt workfile.bak
goto start

REM ###############################
REM Submit all results and
REM cancel all reserved workunits
REM ###############################
:jobcancel
if not exist lresults.txt goto jobcancel1
copy workfile.txt workfile.bak >nul
gawk -f do_tosend.awk lresults.txt
type lresults.txt >>lresults_hist.txt
del lresults.txt
if not exist tosend.txt goto error_notos
set /p =[%Date:~-4%-%Date:~-7,2%-%Date:~-10,2% %Time:~,8%] <nul >>lresults_hist.txt
gawk -f do_clearwork.awk tosend.txt
move /Y workfile.new workfile.txt >nul

:jobcancel1
if exist workfile.txt goto jobcancel2
echo There're no jobs to cancel!
goto bye

:jobcancel2
llrnet -c
echo All jobs canceled!
del tosend.txt, workfile.txt, workfile.res, workfile.bak, llr.ini, z*
goto bye

REM ###############################
REM ERRORS here
REM ###############################

:error_noconnection
if %op_conncet%==FALSE goto bye
echo No pairs are available at this time.
echo Either the server has dried out or there is a problem connecting to the server.
echo Sleeping %op_Timeout% seconds before trying again.
waits %op_Timeout%
goto do_llrnet

:error_nowork
echo ERROR: No workfile.txt found for LLR!
goto bye

:error_nolres
echo ERROR: No lresults.txt found for conversion!
goto bye

:error_notos
echo ERROR: No tosend.txt found for submitting to LLRnet-server!

:bye
if %op_Beep%==FALSE goto byebye
echo 
waits 1
echo 
waits 1
echo 
:byebye
